% naten obrzk
A = imread('A.png');
B = imread('B.png');
C = imread('C.png');
D = imread('D.png');

[s,s1,u] = size(A);

% vytvoen matice vstupnch vektor
x = [];
x(1,:) = double(mean(double(reshape(A,s*s1,3))'/256)>0.5);
x(2,:) = double(mean(double(reshape(B,s*s1,3))'/256)>0.5);
x(3,:) = double(mean(double(reshape(C,s*s1,3))'/256)>0.5);
x(4,:) = double(mean(double(reshape(D,s*s1,3))'/256)>0.5);
x = x.*2-1
[l,k] = size(x);

% Hebbovsk uen
W = zeros(k,k);
for i =1:l
    W = W + x(i,:)' * x(i,:);
end

% Rozpoznvn
sgn = @(x) (x >= 0).*2-1;

y = zeros(l,k);
for i =1:l
   y(i,:) =  sgn( x(i,:) * W);
end

% vytvoen vsledn bitmapy
for i=1:l
    yv = [y(i,:) y(i,:) y(i,:)];
    V = uint8(reshape(yv'*256,s,s1,u));
    sv = strcat('V',num2str(i),'.bmp');
    imwrite(V,sv);
end

% rozpoznn jinho vzoru
A1 = imread('A1.png');
x1 = double(mean(double(reshape(A1,s*s1,3))'/256)>0.5);
x1 = x1.*2-1;
y1 = sgn( x1 * W);

 yv = [y1 y1 y1];
 V = uint8(reshape(yv'*256,s,s1,u));
 imwrite(V,'V.bmp');

